@use '@angular/material' as mat;
@use 'sass:map';

@mixin color($theme) {
  $color-config: mat.get-color-config($theme);
  $primary-palette: map.get($color-config, 'primary'); // Primary Palette is Grey, currently used to add shadows to accorrdions
  $accent-palette: map.get($color-config, 'accent'); // Accent Palette is Blue, used as primary button colour
  $warn-palette: map.get($color-config, 'warn'); // Warn Palette is Pink, used as accent button colour

  .footer {
      color: mat.get-color-from-palette($accent-palette, 500-contrast);
      background-color: mat.get-color-from-palette($accent-palette, 500);
  }

  .skao-spacer {
      background-color: mat.get-color-from-palette($accent-palette, 500);
  }

  // Header colours

  .title-style {
      color: mat.get-color-from-palette($accent-palette, 500);
  }

  .mat-icon-button {
    color: mat.get-color-from-palette($accent-palette, 500);
    border-color: mat.get-color-from-palette($accent-palette, 500) !important;
  }

  // Tab colours

  .mat-tab-label{
    color: mat.get-color-from-palette($accent-palette, 500-contrast);
    background-color: mat.get-color-from-palette($accent-palette, 500);
  }

  .mat-ink-bar {
    background-color: mat.get-color-from-palette($accent-palette, 500) !important;
  }

  .mat-tab-label:hover, .mat-tab-label-active {
      background-color: mat.get-color-from-palette($accent-palette, 200);
  }

  // Button colours

  .mat-button, .mat-raised-button  {
      color: mat.get-color-from-palette($accent-palette, 500-contrast);
      background: mat.get-color-from-palette($accent-palette, 500);
  }

  .mat-button:hover, .mat-raised-button:hover {
      &:enabled {
      background: mat.get-color-from-palette($accent-palette, 700);
      color: mat.get-color-from-palette($accent-palette, 700-contrast);
      }
  }


  // Calculate Button colours
  
  .mat-button.mat-warn, .mat-raised-button.mat-warn  {
    color: mat.get-color-from-palette($warn-palette, 500-contrast);
    background: mat.get-color-from-palette($warn-palette, 500);
  }

  .mat-button.mat-warn:hover, .mat-raised-button.mat-warn:hover {
      &:enabled {
      background: mat.get-color-from-palette($warn-palette, 700);
      color: mat.get-color-from-palette($warn-palette, 700-contrast);
      }
  }

  // Band toggle

  .mat-button-toggle:hover {
      background-color: mat.get-color-from-palette($accent-palette, 700);
      color: mat.get-color-from-palette($accent-palette, 700-contrast);
  }

  .mat-button-toggle-checked {
      background-color: mat.get-color-from-palette($accent-palette, 200);
      color: mat.get-color-from-palette($accent-palette, 200-contrast);
  }

  .mat-button-toggle-checked.mat-button-toggle-appearance-standard {
      font-weight: bold;
      color: mat.get-color-from-palette($accent-palette, 500-contrast);
  }

  // Unit dropdowns within a form
  .units-button {
    .mat-button {
      color: mat.get-color-from-palette($primary-palette, 500-contrast);
    }

    .mat-button:hover {
      color: mat.get-color-from-palette($primary-palette, 500-contrast);
    }
  }

  // Links
  a {
    color: mat.get-color-from-palette($accent-palette, 700);
  }

  a:visited {
    color: mat.get-color-from-palette($accent-palette, 200);
  }

  // Input field colours

  .mat-hint {
      color: mat.get-color-from-palette($primary-palette, 500-contrast);
  }

  // Accordions
  .mat-expansion-panel{
    background-color: mat.get-color-from-palette($accent-palette, 100-contrast);
  }

  .mat-expansion-panel:not([class*=mat-elevation-z]) {
    box-shadow: 0px 3px 1px -2px mat.get-color-from-palette($primary-palette, 500), 0px 2px 2px 0px mat.get-color-from-palette($primary-palette, 300), 0px 1px 5px 0px mat.get-color-from-palette($primary-palette, 200);
  }


  // Mid result table colours
  .mat-card {
    background-color: mat.get-color-from-palette($accent-palette, 100-contrast);
  }

  .mat-form-field .mat-form-field-label {
    color: mat.get-color-from-palette($primary-palette, 500-contrast);
    opacity: 1.0;
  }

  .mat-form-field-appearance-fill .mat-form-field-underline::before {
    background-color: mat.get-color-from-palette($primary-palette, 100-contrast);
  }

  .mat-form-field.mat-focused .mat-form-field-label {
    color: mat.get-color-from-palette($accent-palette, 100);
    opacity: 1.0;
  }

  .mat-form-field.mat-focused .mat-form-field-ripple {
    background-color: mat.get-color-from-palette($accent-palette, 100);
  }


  .fake-form-field-outline {
    border-color: mat.get-color-from-palette($primary-palette, 500-contrast);
  }

  .fake-form-field {
    border-color: mat.get-color-from-palette($primary-palette, 500-contrast);
    background-color: mat.get-color-from-palette($accent-palette, 500-contrast);

  }


  .snackbar-error {
      background-color: mat.get-color-from-palette($accent-palette, 500);
      color: mat.get-color-from-palette($accent-palette, 500-contrast);
  }

  .mat-header-cell {
    background-color: mat.get-color-from-palette($accent-palette, 500);
    color: mat.get-color-from-palette($accent-palette, 500-contrast);
  }


  // Setting Error colour manually to Red, overriding warn colour palette which has been set to Pink
  $default-warn-color: #F44336;

  .mat-error {
    color: $default-warn-color
  }

  .mat-form-field.mat-form-field-invalid .mat-form-field-ripple, .mat-form-field.mat-form-field-invalid .mat-form-field-ripple.mat-accent {
    background-color: $default-warn-color
  }

  .mat-form-field.mat-form-field-invalid .mat-form-field-label, .mat-form-field.mat-form-field-invalid .mat-form-field-label.mat-accent, .mat-form-field.mat-form-field-invalid .mat-form-field-label .mat-form-field-required-marker {
    color: $default-warn-color
  }


  // Result output parameters changed colours
  .warning-border {
    border-color: $default-warn-color !important;
  }

  .mat-form-field .mat-input-element {
    caret-color: mat.get-color-from-palette($primary-palette, 500-contrast);
  }
}
